## ros-humble-foros 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(foros)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(foros_msgs REQUIRED)
find_package(leveldb REQUIRED)

include_directories(src)

set(${PROJECT_NAME}_SRCS
  src/cluster_node.cpp
  src/cluster_node_options.cpp
  src/cluster_node_impl.cpp
  src/command.cpp
  src/common/node_util.cpp
  src/raft/context.cpp
  src/raft/context_store.cpp
  src/raft/other_node.cpp
  src/raft/state.cpp
  src/raft/state_machine.cpp
  src/raft/state/candidate.cpp
  src/raft/state/follower.cpp
  src/raft/state/leader.cpp
  src/raft/state/standby.cpp
  src/raft/inspector.cpp
  src/lifecycle/state.cpp
  src/lifecycle/state/active.cpp
  src/lifecycle/state/inactive.cpp
  src/lifecycle/state/standby.cpp
)

add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SRCS})

target_include_directories(${PROJECT_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

ament_target_dependencies(${PROJECT_NAME}
  rclcpp
  foros_msgs
  leveldb
)

# why shoud I put it as well?? need to check
target_link_libraries(${PROJECT_NAME} leveldb)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_export_dependencies(rclcpp foros_msgs leveldb)

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_cmake_cpplint REQUIRED)
  ament_cpplint(FILTERS "-build/header_guard,-build/include_order")

  find_package(ament_cmake_cppcheck REQUIRED)
  ament_cppcheck()

  find_package(ament_cmake_lint_cmake REQUIRED)
  ament_lint_cmake()

  find_package(ament_cmake_xmllint REQUIRED)
  ament_xmllint()

  add_subdirectory(test)
endif()

ament_package()

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)

ament_add_gmock(
  test_cluster_node
  test_cluster_node.cpp)
target_link_libraries(test_cluster_node ${PROJECT_NAME})

ament_add_gtest(
  test_lifecycle_state_machine
  test_lifecycle_state_machine.cpp)
target_link_libraries(test_lifecycle_state_machine ${PROJECT_NAME})

ament_add_gmock(
  test_raft
  test_raft.cpp)
target_link_libraries(test_raft ${PROJECT_NAME})

ament_add_gmock(
  test_raft_with_inspector
  test_raft_with_inspector.cpp)
target_link_libraries(test_raft_with_inspector ${PROJECT_NAME})

=== debian/changelog ===
ros-humble-foros (0.4.1-3bookworm) bookworm; urgency=high

  * foros: update package.xml test_depend
    add ament_cmake_gtest, ament_cmake_gmock
  * foros: update package.xml depend
    libleveldb-dev -> leveldb
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Sat, 12 Nov 2022 16:00:00 -0000

ros-humble-foros (0.4.0-3bookworm) bookworm; urgency=high

  * version 0.4.0
  * foros: remove private member access from public method
  * Added humble branch (#1)
    foros: migration to humble hawksbill
    - asnyc_send_request() returns a std::future instead of a std::shared_future
    - get_callback_group() is replaced with for_each_callback_group()
    - publish() is not a virtual function anymore
  * foros: fix unused variable, uninitialize fields
    fix CID 257409, 257410, 257421, 257426, 257433
  * docs: integrate coverity scan, remove dead link
  * Contributors: Taehun Lim, Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Wed, 26 Oct 2022 16:00:00 -0000

ros-humble-foros (0.3.1-3bookworm) bookworm; urgency=high

  * Version 0.3.1
    - inspector UI enhanced
    - unit test updated
  * foros: unittest updated
    add raft unittest when inspector is enabled
  * docs: inspector screenshot updated
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Tue, 26 Apr 2022 16:00:00 -0000

ros-humble-foros (0.3.0-3bookworm) bookworm; urgency=high

  * docs: doxygen updated
    show test result using inspector not console
  * Version 0.3.0
    - inspector introduced
    - locking added for multithreading
  * foros: remove unnecessary logs
  * foros: add default period of instpector
  * foros: fill timstamp in inspector msg
  * foros: send cluster_size to inspector
  * foros: inspector implemented
    enable inspector with environment variables
    - FOROS_INSPECTOR : 1 to enable
    - FOROS_INSPECTOR_PERIOD : inspector message publish period
    if inspector is enabled, publish inspector message every
    FOROS_INSPECTOR_PERIOD second(s)
  * foros: add mutex for supporting multithread
    add mutex for
    - callback of observable
    - state transition of state machine
    - data getter/setter of context store
    - commit/revert callback of context
    - index of other node
  * docs: fix test failure of doxygen mainpage
    add new line at the end of foros/docs/foros.hpp
  * docs: doxygen main page added
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Sun, 24 Apr 2022 16:00:00 -0000

ros-humble-foros (0.1.0-3bookworm) bookworm; urgency=high

  * foros: raft state machine TC added
  * foros: more unit TC
  * foros: unit TC added
    - add more test for cluster node class
    - add raft context, context store test cases
  * foros: refine functio signature
  * foros: raft TC added, coverage script added
  * foros: context store ldata loading bug fix
  * foros_msgs: rename fields
    - data -> entries
    - prev_data_term -> prev_log_term
    - prev_data_index -> prev_log_index
  * foros: maintain command logs by framework not user
    as-is: maintains command logs (data) outside (by user)
    to-be: maintains command logs internally using leveldb (by framework)
  * foros: maintain persistent data using leveldb
    election_term, voted_for, voted values should be
    stored in storage. (deleted on reboot)
    Therefore,
    1) created raft context store using leveldb
    2) add options to set temp directory. default is
    std::filesystem::temp_directory_path()
    TODO: add command logs in store
  * foros: check validity of raft RPC
    check whether the RAFT message is sent
    by node which is not included in the cluster.
  * foros: quorum calculation changed
    as-is: calculate quorum from the number of available candidates
    to-be: calculate quorum from full cluster
  * foros: use rclcpp logger not std::cerr, std::cout
  * foros: data commit API implemented
  * foros: fix method signiture mismatch
  * foros: refine cluster node data itnerface
    Do not use internal terminology in APIs
    - index -> id
    - term -> sub_id
  * foros: align doxygen style
  * foros: add data constructor
  * foros: specify missing const arg of function
  * foros: update commit index, next index as needed
    1) update last commit index,
    - on local commit
    - on rollback commit
    2) update next indeice of other nodes, when the node becomes leader
  * foros: send current commit index in the vote request RPC
  * foros: data replication logic added (phase 1)
    - implemented replication using broadcast
    - example added
    TODO:
    - bug fix
    - implement replication using data commit API
  * foros: add lifecycle callback register APIs
    The virtual function is not guarenteed to be invoked in the constructor.
    Therefore, uses register APIs not overriding
    As-Is: overriding using interface
    To-Be: register using API explicitly
  * foros: rename callbacks of data interface
  * foros: initialize the last commit index
  * foros: add data replicatoin logic in RPC response
  * foros: the lastest data request interface added
  * foros: CommitInfo class added
    CommitInfo stores the index, the term, request counts.
    It used for storing commit information in the pending commits map.
  * fsros: add prev commt info in Data class
    To achieve raft data duplication, need to pass previous commit index
    and previous commit term.
  * foros: store term, request count in pending commit
  * foros: rename interfaces, add more doxygen
  * foros: data commit interface added
    for data replication,
    1) add data interface API
    2) data commit API added in raft context
  * foros: align coding style (CommitData, CommitResponse)
  * foros: change commit data API to asnyc API
    This API need to make a consensus in the cluster.
    Therefore, change to async API.
    - use promise-future
    - for now, return result immediately
    until the business logic is implemented.
  * rename failsafe::fsros to failover::foros


=== debian/control ===
Source: ros-humble-foros
Section: misc
Priority: optional
Maintainer: Wonguk Jeong <wonguk.jeong@42dot.ai>
Build-Depends: debhelper (>= 9.0.0), libleveldb-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-foros-msgs, ros-humble-rclcpp, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-foros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libleveldb-dev, ros-humble-foros-msgs, ros-humble-rclcpp, ros-humble-ros-workspace
Description: Fail Over ROS framework

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-foros//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-foros//opt/ros/humble/opt/foros/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
